;EasyCodeName=RSEditHelp
;
         Title  RSEdit Function Assistant
; ___________________________________________________
;|                                                   |
;|      RSEdit Function Library - Version 1.0.0      |
;|        -----------------------------------        |
;| pbrennick@verizon.net -- http://www.pbrennick.com |
;| ------------------------------------------------- |
;|                                                   |
;| Version key is as follows:                        |
;|           RSEdit Function Assistant a.b.c         |
;|           -------------------------------         |
;|                a:  a major change to the GUI      |
;|                b:  functions added and/or changed |
;|                c:  bug fixes                      |
;|                                                   |
;| Version History:                                  |
;| ----------------                                  |
;| 03Feb2004  Finalize the code in preparation of    |
;|            releasing it to Ramon.                 |
;| 02Mar2004  First public release of the software,  |
;|            to Ramon, of course.                   |
;| 01Mar2004  In a fit of pique, I removed all code  |
;|            from the DLL and trashed it in favor   |
;|            of all the code being integrated with  |
;|            the executable.                        |
;| 25Feb2004  The DLL I am using to serve the        |
;|            function table is giving me a bit of   |
;|            trouble on my XP box, it runs better   |
;|            on my '98SE box.  This could lead to   |
;|            future problems.                       |
;|___________________________________________________|
;
; Macro Section
;---------------------------------------
szText  Macro   Name, Text:VarArg
        Local   lbl

        Jmp     lbl
Name    DB      Text, 0
lbl:
        EndM
;
m2m     Macro   M1, M2
        Push    M2
        Pop     M1
        EndM
;
.Data
;---------------------------------------
szDisplayName   DB  "RSEdit Functions", 0
CommandLine     DD  0
hwnd            DD  0
hInstance       DD  0
hList           DD  0
lpListBox       DD  0
SpecialDLGName  DB  'SpecialDLG', 0     ; Special Help/Information Dialog Box
SalaBlurb       DB  "My name is Ramon Sala and  I", 39, "m catalan. Catalonia belongs politically "
                DB  "to Spain, but we have our own government and language. When you enter my web page, "
                DB  "catalan is the language it is written in, and there are two links (signaled with "
                DB  "their respective flags) for english and spanish pages.  I like programming a lot, so "
                DB  "that is what I do in my free time.  I hope you like and enjoy my applications "
                DB  "(which are always free).", 0, 0
LineItem        DB  "rsCreateEditor", 0
                DB  "rsChangeControlColors", 0
                DB  "rsCheckModified", 0
                DB  "rsClearNextUndoEntry", 0
                DB  "rsClearUndoBuffer", 0
                DB  "rsCopyString", 0
                DB  "rsDecrementUndoCount", 0
                DB  "rsDisplayCursor", 0
                DB  "rsExpandTabStops", 0
                DB  "rsFindFirstChar", 0
                DB  "rsFindHook", 0
                DB  "rsFindNextWord", 0
                DB  "rsFindPrevWord", 0
                DB  "rsFindText", 0
                DB  "rsGetLineAndExpandTabs", 0
                DB  "rsGetLineFromChar", 0
                DB  "rsGetLineIndex", 0
                DB  "rsGetLineLength", 0
                DB  "rsGetMemoryPosition", 0
                DB  "rsGetNextLineIndex", 0
                DB  "rsGetPrevLineIndex", 0
                DB  "rsGetRealColWidth", 0
                DB  "rsGetStringLength", 0
                DB  "rsInitEditor", 0
                DB  "rsInsertText", 0
                DB  "rsIsAlpha", 0
                DB  "rsIsAlphaNumeric", 0
                DB  "rsLineScroll", 0
                DB  "rsMakeSelectionVisible", 0
                DB  "rsMoveMemory", 0
                DB  "rsPaintControl", 0
                DB  "rsProcessLButtonDown", 0
                DB  "rsRedoAction", 0
                DB  "rsReplaceSelection", 0
                DB  "rsResizeTextBuffer", 0
                DB  "rsSaveUndoBufer", 0
                DB  "rsSaveUndoRedoText", 0
                DB  "rsSearchCaseDown", 0
                DB  "rsSearchCaseUp", 0
                DB  "rsSearchNoCaseDown", 0
                DB  "rsSearchNoCaseUp", 0
                DB  "rsSearchText", 0
                DB  "rsSelectWord", 0
                DB  "rsSendNotifyMessage", 0
                DB  "rsSetCaret", 0
                DB  "rsSetFirstLineIndex", 0
                DB  "rsStoreUndoText", 0
                DB  "rsUndoAction ", 0
                DB  0
rsCreateEditor  DB  "Name:     rsCreateEditor", 13, 10
                DB  "Function: Creates a new instance of the RS Edit control", 13, 10
                DB  13, 10
                DB  "Params:   hwndParent = Handle of the parent", 13, 10
                DB  "          dwStyle    = Normal style (WS_CHILD, WS_VISIBLE, etc.)", 13, 10
                DB  "          dwExStyle  = Extended style (WS_EX_CLIENTEDGE, etc.)", 13, 10
                DB  "          lLeft      = X position (in pixels)", 13, 10
                DB  "          lTop       = Y position (in pixels)", 13, 10
                DB  "          lWidth     = Width (in pixels)", 13, 10
                DB  "          lHeight    = Height (in pixels)", 13, 10
                DB  13, 10
                DB  "Returns: The handle of the new created control in EAX", 0
rsChangeControlColors  DB  "Name:     rsChangeControlColors", 13, 10
                DB  "Function: Changes one or more of the RS Edit control colors", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lFlags     = Colors that must be changed", 13, 10
                DB  13, 10
                DB  "Bits meaning:     0 = 1 -> Changes the editor background", 13, 10
                DB  "                  1 = 1 -> Changes the selection bar background", 13, 10
                DB  "                  2 = 1 -> Changes the editor text color", 13, 10
                DB  "                  3 = 1 -> Changes the editor selection background", 13, 10
                DB  "                  4 = 1 -> Changes the editor selection text color", 0
rsCheckModified DB  "Name:     rsCheckModified", 13, 10
                DB  "Function: Checks if text is unmodified due to undo / redo operations", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 0
rsClearNextUndoEntry  DB  "Name:     rsClearNextUndoEntry", 13, 10
                DB  "Function: Clears the undo entry specified by the 'lpUndoCount' member of", 13, 10
                DB  "          the RS Edit control's data structure", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 0
rsClearUndoBuffer  DB  "Name:     rsClearUndoBuffer", 13, 10
                DB  "Function: Clears the undo/redo buffer", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 0
rsCopyString    DB  "Name:     rsCopyString", 13, 10
                DB  "Function: Copies an ASCIIZ string into another", 13, 10
                DB  13, 10
                DB  "Params:  lpDest = Destination address of the copy", 13, 10
                DB  "Params:  lpDest = Source address of the copy", 13, 10
                DB  13, 10
                DB  "Returns: The length of the copied string in EAX", 0
rsDecrementUndoCount  DB  "Name:     rsDecrementUndoCount", 13, 10
                DB  "Function: Decrements the undo / redo operations count", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 0
rsDisplayCursor DB  "Name:     rsDisplayCursor", 13, 10
                DB  "Function: Creates a caret and displays it on the screen", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 0
rsExpandTabStops DB  "Name:     rsExpandTabStops", 13, 10
                DB  "Function: Converts tabs to spaces", 13, 10
                DB  13, 10
                DB  "Params:   lpszLine   = Address ob buffer to store spaces", 13, 10
                DB  "          lpLength   = Address of the current length of lpszLine", 13, 10
                DB  13, 10
                DB  "Remarks:  Ebx must point to the RS Edit control's data structure", 13, 10
                DB  "          Edx must point to expanded tabs buffer (lpszLine+length)", 0
rsFindFirstChar DB  "Name:     rsFindFirstChar", 13, 10
                DB  "Function: Finds the first character not being a control character", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  13, 10
                DB  "Returns: The zero based position of the character inside the line in EAX", 0
rsFindHook      DB  "Name:     rsFindHook", 13, 10
                DB  "Function: Called by 'rsIsAlpha' procedure. It can be subclassed by user", 13, 10
                DB  "          to decide which characters are treated like a word break or not", 13, 10
                DB  13, 10
                DB  "Params:   chr = Character to be compared to", 13, 10
                DB  13, 10
                DB  "Returns:  TRUE  = Character is treated like part of word (no word-break)", 13, 10
                DB  "          FALSE = Character is interpreted like a word-break", 0
rsFindNextWord  DB  "Name:     rsFindNextWord", 13, 10
                DB  "Function: Finds the next word after the cursor", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lIndex     = Current character index (where the cursor is)", 13, 10
                DB  13, 10
                DB  "Returns: The character index of the next word in EAX", 0
rsFindPrevWord  DB  "Name:     rsFindPrevWord", 13, 10
                DB  "Function: Finds the previous word before the cursor", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lIndex     = Current character index (where the cursor is)", 13, 10
                DB  13, 10
                DB  "Returns: The character index of the previous word in EAX", 0
rsFindText      DB  "Name:     rsFindText", 13, 10
                DB  "Function: Finds text according to an RSSFINDTEXT structure", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lFlags     = Flags for searching", 13, 10
                DB  "          rssFt      = Structure specifying what and how to search", 13, 10
                DB  13, 10
                DB  "Returns:  The character index of the text or -1 if not found in EAX", 0
rsGetLineAndExpandTabs  DB  "Name:     rsGetLineAndExpandTabs", 13, 10
                DB  "Function: Gets the line in the 'lpszLine' member buffer of the RS Edit", 13, 10
                DB  "          control data structure, with expanded tabs, ready to be painted", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lIndex     = Character index of the line to be retreived", 13, 10
                DB  "          chr        = Address of a CHARSEL structure", 13, 10
                DB  13, 10
                DB  "Returns: The length of the expanded line in EAX", 0
rsGetLineFromChar  DB  "Name:     rsGetLineFromChar", 13, 10
                DB  "Function: Gets the zero based line number for the given index", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lIndex     = Character index whose number is to be retreived", 13, 10
                DB  "          bLineIndex = If TRUE, the new line index is stored in the", 13, 10
                DB  "                       'lLineIndex' member of the data structure", 13, 10
                DB  13, 10
                DB  "Returns: The zero based line for the indicated index", 0
rsGetLineIndex  DB  "Name:     rsGetLineIndex", 13, 10
                DB  "Function: Gets the line index for the given line", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lLine      = Line number whose line index is to be retreived", 13, 10
                DB  13, 10
                DB  "Returns: The line index for the indicated line", 0
rsGetLineLength DB  "Name:     rsGetLineLength", 13, 10
                DB  "Function: Gets the line length for the given index", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lIndex     = Index of a char belonging to the line whose length", 13, 10
                DB  "                       is to be retreived", 13, 10
                DB  13, 10
                DB  "Returns: The length of the line (including the carriage return) in EAX", 0
rsGetMemoryPosition  DB  "Name:     rsGetMemoryPosition", 13, 10
                DB  "Function: Gets the zero based position inside the line of the char stored", 13, 10
                DB  "          in the 'ptPos.x' member (column) of the data structure", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  13, 10
                DB  "Returns: The zero based position of the char in memory in EAX", 0
rsGetNextLineIndex  DB  "Name:     rsGetNextLineIndex", 13, 10
                DB  "Function: Gets the next line index (beginning of the next line)", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData    = Address of the RS Edit control's data structure", 13, 10
                DB  "          lCurrentIndex = Current line index (line index of current line)", 13, 10
                DB  13, 10
                DB  "Returns: The next line index in EAX", 0
rsGetPrevLineIndex  DB  "Name:     rsGetPrevLineIndex", 13, 10
                DB  "Function: Gets the previous line index (beginning of the previous line)", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData    = Address of the RS Edit control's data structure", 13, 10
                DB  "          lCurrentIndex = Current line index (line index of current line)", 13, 10
                DB  13, 10
                DB  "Returns: The previous line index in EAX", 0
rsGetRealColWidth  DB  "Name:     rsGetRealColWidth", 13, 10
                DB  "Function: Gets the real column width (with tabs expanded) in pixels", 13, 10
                DB  13, 10
                DB  "Returns: The length of the entire line in pixels", 0
rsGetStringLength  DB  "Name:     rsGetStringLength", 13, 10
                DB  "Function: Gets the length of an ASCIIZ string (saving Ecx and Edx)", 13, 10
                DB  13, 10
                DB  "Params:  lpszBuf = Address of the string whose length is to be retreived", 13, 10
                DB  13, 10
                DB  "Returns: The length of indicated string in EAX", 0
rsInitEditor    DB  "Name:     rsInitEditor", 13, 10
                DB  "Function: Initializes the RS Edit's data structure", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lLength    = Length of the text in the editor or -1. If -1,", 13, 10
                DB  "                       the length is unknown and has to be retreived", 0
rsInsertText    DB  "Name:     rsInsertText", 13, 10
                DB  "Function: Inserts text (or removes it) in the RS Edit control's memory", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lpszChar   = Addres of text to be inserted", 13, 10
                DB  13, 10
                DB  "Returns:  The length of the inserted text", 0
rsIsAlpha       DB  "Name:     rsIsAlpha", 13, 10
                DB  "Function: Specifies whether a character is a letter or not", 13, 10
                DB  13, 10
                DB  "Params:   chr        = Character to check", 13, 10
                DB  "          prFindProc = Address of the FindProc function", 13, 10
                DB  13, 10
                DB  "Returns:  TRUE if chr is an alpha character, FALSE if not", 0
rsIsAlphaNumeric DB  "Name:     rsIsAlphaNumeric", 13, 10
                DB  "Function: Specifies whether a character is alphanumeric or not", 13, 10
                DB  13, 10
                DB  "Params:   chr        = Character to check", 13, 10
                DB  "          prFindProc = Address of the FindProc function", 13, 10
                DB  13, 10
                DB  "Returns:  TRUE if chr is a letter or o number, FALSE if not", 0
rsLineScroll    DB  "Name:     rsLineScroll", 13, 10
                DB  "Function: Scrolls controls' text the specified number of columns/lines", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lCols      = Number of columns to be scrolled", 13, 10
                DB  "          lLines     = Number of lines to be scrolled", 13, 10
                DB  13, 10
                DB  "Returns:  Nothing", 13, 10
                DB  13, 10
                DB  "Remarks:  To scroll to left or top, specify negative values", 0
rsMakeSelectionVisible  DB  "Name:     rsMakeSelectionVisible", 13, 10
                DB  "Function: Sets the best line index for the first visible line, in order", 13, 10
                DB  "          to center the word in the indexes indicated by 'lStart - lEnd'", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lPos       = Character index to check for", 13, 10
                DB  13, 10
                DB  "Returns:  Nothing", 0
rsMoveMemory    DB  "Name:     rsMoveMemory", 13, 10
                DB  "Function: Moves 'lCount' bytes from 'lpszSource' to 'lpszDest'", 13, 10
                DB  13, 10
                DB  "Params:   lpszSource = Address of the source of data to be moved", 13, 10
                DB  "          lpszDest   = Address of the destination where to move to", 13, 10
                DB  "          lCount     = Number of bytes to be moved", 13, 10
                DB  13, 10
                DB  "Returns:  Nothing", 0
rsPaintControl  DB  "Name:     rsPaintControl", 13, 10
                DB  "Function: Paints the entire RS Edit control (processes WM_PAINT)", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the control's data", 13, 10
                DB  13, 10
                DB  "Returns:  Nothing", 13, 10
                DB  13, 10
                DB  "Remarks:  If an address for a 'Paint proc' has been set (refer to message", 13, 10
                DB  "          RSM_SETPAINTPROC) RSEdit gives control to that procedure and", 13, 10
                DB  "          does not paint anything.", 0
rsProcessLButtonDown  DB  "Name:     rsProcessLButtonDown", 13, 10
                DB  "Function: Processes WM_LBUTTONDOWN message", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData  = Address of the RS Edit control's data structure", 13, 10
                DB  "          wMsg        = Value of uMsg parameter", 13, 10
                DB  "          wParam      = Value of wParam parameter", 13, 10
                DB  "          lParam      = Value of lParam parameter", 13, 10
                DB  13, 10
                DB  "Returns:  The character index where the mouse clicked", 0
rsRedoAction    DB  "Name:     rsRedoAction", 13, 10
                DB  "Function: Performs a redo action (if any)", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  13, 10
                DB  "Returns:  Nothing", 0
rsReplaceSelection  DB  "Name:     rsReplaceSelection", 13, 10
                DB  "Function: Replaces selected text with text specified by lpszChar", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lpszChar   = Address of new text", 13, 10
                DB  "          lKey       = Key code for undo action (-1 if no undo)", 13, 10
                DB  13, 10
                DB  "Returns:  Nothing", 13, 10
                DB  13, 10
                DB  "Remarks:  If there is no text selected, the new text is inserted in the", 13, 10
                DB  "          caret's position (the insertion point)", 0
rsResizeTextBuffer  DB  "Name:     rsResizeTextBuffer", 13, 10
                DB  "Function: Resizes text buffer to fit the new text length", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lBytes     = Number of bytes to be add", 13, 10
                DB  13, 10
                DB  "Returns:  Nothing", 0
rsSaveUndoBufer DB  "Name:     rsSaveUndoBufer", 13, 10
                DB  "Function: Saves the undo buffer contents (one key strokes)", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  13, 10
                DB  "Returns:  Nothing", 0
rsSaveUndoRedoText  DB  "Name:     rsSaveUndoRedoText", 13, 10
                DB  "Function: Saves blocks of text for undo / redo operations", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          szNewText  = Address of new text", 13, 10
                DB  13, 10
                DB  "Returns:  Nothing", 0
rsSearchCaseDown  DB  "Name:     rsSearchCaseDown", 13, 10
                DB  "Function: Searches text down (case sensitive) from a specified position", 13, 10
                DB  13, 10
                DB  "Params:   lpText   = Buffer containing text to search for", 13, 10
                DB  "          lpSearch = Address for buffer where to start searching", 13, 10
                DB  "          lPointer = Address of the first char in controls' text buffer", 13, 10
                DB  13, 10
                DB  "Returns:  The character index of the text or -1 if not found in Eax", 0
rsSearchCaseUp  DB  "Name:     rsSearchCaseUp", 13, 10
                DB  "Function: Searches text up (case sensitive) from a specified position", 13, 10
                DB  13, 10
                DB  "Params:   lpText   = Buffer containing text to search for", 13, 10
                DB  "          lpSearch = Address for buffer where to start searching", 13, 10
                DB  "          lPointer = Address of the first char in controls' text buffer", 13, 10
                DB  13, 10
                DB  "Returns:  The character index of the text or -1 if not found in EAX", 0
rsSearchNoCaseDown  DB  "Name:     rsSearchNoCaseDown", 13, 10
                DB  "Function: Searches text down (case insensitive) from a specified position", 13, 10
                DB  13, 10
                DB  "Params:   lpText   = Buffer containing text to search for", 13, 10
                DB  "          lpSearch = Address for buffer where to start searching", 13, 10
                DB  "          lPointer = Address of the first char in controls' text buffer", 13, 10
                DB  13, 10
                DB  "Returns:  The character index of the text or -1 if not found in EAX", 0
rsSearchNoCaseUp DB  "Name:     rsSearchNoCaseUp", 13, 10
                DB  "Function: Searches text up (case insensitive) from a specified position", 13, 10
                DB  13, 10
                DB  "Params:   lpText   = Buffer containing text to search for", 13, 10
                DB  "          lpSearch = Address for buffer where to start searching", 13, 10
                DB  "          lPointer = Address of the first char in controls' text buffer", 13, 10
                DB  13, 10
                DB  "Returns:  The character index of the text or -1 if not found in EAX", 0
rsSearchText    DB "Name:     rsSearchText", 13, 10
                DB  "Function: Searches text according to flags and RSSFINDTEXT structure", 13, 10
                DB  13, 10
                DB  "Params:   lpText   = Buffer containing text to search for", 13, 10
                DB  "          lFlags   = Flags indicating how to search text", 13, 10
                DB  "          lPointer = Address of the first char in controls' text buffer", 13, 10
                DB  "          lpSearch = Address for buffer where to start searching", 13, 10
                DB  13, 10
                DB  "Returns:  The character index of the text or -1 if not found in EAX", 0
rsSelectWord    DB  "Name:     rsSelectWord", 13, 10
                DB  "Function: Fills the 'chrPos' member of the edit data structure with the", 13, 10
                DB  "          character indexes of the word which is in the position specified", 13, 10
                DB  "          by 'lPos' parameter. If there is no word, it fills the 'chrPos'", 13, 10
                DB  "          member with the value specified by 'lPos' parameter.", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          lPos       = Character index of any part of the text", 13, 10
                DB  "          bSpaces    = Specifies whether spaces and tabs (blanks) will be", 13, 10
                DB  "                     = taken into account (TRUE = Yes).", 13, 10
                DB  13, 10
                DB  "Returns:  Nothing", 0
rsSendNotifyMessage  DB  "Name:     rsSendNotifyMessage", 13, 10
                DB  "Function: Sends a WM_NOTIFY message to the parent window", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  "          uCode      = The code of the message (NM_CLICK, NM_DBLCLK, etc.)", 13, 10
                DB  13, 10
                DB  "Returns:  Nothing", 0
rsSetCaret      DB  "Name:     rsSetCaret", 13, 10
                DB  "Function: Positions the caret in the x, y coordinates (specified by the", 13, 10
                DB  "          members 'ptPos.x' and 'ptPos.y' of the data structure)", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  13, 10
                DB  "Returns:  Nothing", 0
rsSetFirstLineIndex  DB  "Name:     rsSetFirstLineIndex", 13, 10
                DB  "Function: Sets the line index for the first visible line", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  13, 10
                DB  "Returns:  Nothing", 0
rsStoreUndoText DB  "Name:     rsStoreUndoText", 13, 10
                DB  "Function: Stores modified text for undo operations", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  13, 10
                DB  "Retuns:   Nothing", 0
rsUndoAction    DB  "Name:     rsUndoAction", 13, 10
                DB  "Function: Performs an undo action (if any)", 13, 10
                DB  13, 10
                DB  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                DB  13, 10
                DB  "Returns:  Nothing", 0
                DB  0
;
.Data?
;---------------------------------------
ItemBuffer      DB  128 Dup (?)
hMenu           DD  ?
hfMnu           DD  ?
hhMnu           DD  ?
hIcon           DD  ?                   ; Handle
;
.Const
;---------------------------------------
;
;
.Code
;---------------------------------------
start:  Invoke  GetModuleHandle, NULL
	Mov     hInstance, Eax
	Invoke  GetCommandLine
	Mov     CommandLine, Eax
	Invoke  WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	Invoke  ExitProcess, Eax
;
;
WinMain Proc    hInst:DWord, hPrevInst:DWord, CmdLine:DWord, CmdShow:DWord
;---------------------------------------
	Local   wc:WNDCLASSEX
	Local   msg:MSG
	Local   Wwd:DWord
	Local   Wht:DWord
	Local   Wtx:DWord
	Local   Wty:DWord
;    _________________________________________________
;   |                                                 |
;   | Fill WNDCLASSEX Structure With Needed Variables |
;   |_________________________________________________|
;
	Mov     wc.cbSize,         SizeOf WNDCLASSEX
	Mov     wc.style,          CS_HREDRAW Or CS_VREDRAW \
	                           Or CS_BYTEALIGNWINDOW
	Mov     wc.lpfnWndProc,    Offset WndProc
	Mov     wc.cbClsExtra,     NULL
	Mov     wc.cbWndExtra,     NULL
	m2m     wc.hInstance,      hInst            ; << NOTE: macro not mnemonic
	Mov     wc.hbrBackground,  COLOR_BTNFACE+1
	Mov     wc.lpszMenuName,   NULL
	Mov     wc.lpszClassName,  Offset szClassName
	Invoke  LoadIcon, hInst,   500              ; Icon ID
	Mov     wc.hIcon,          Eax
	Invoke  LoadCursor,NULL,   IDC_ARROW
	Mov     wc.hCursor,        Eax
	Mov     wc.hIconSm,        0
	Invoke  RegisterClassEx,   Addr wc
;    _____________________________________
;   |                                     |
;   | Centre window at the following size |
;   |_____________________________________|
;
	Mov     Wwd, 235
	Mov     Wht, 275
	Invoke  GetSystemMetrics, SM_CXSCREEN
	Invoke  TopXY, Wwd, Eax
	Mov     Wtx, Eax
	Invoke  GetSystemMetrics, SM_CYSCREEN
	Invoke  TopXY, Wht, Eax
	Mov     Wty, Eax
	szText  szClassName,    "Template_Class"
	Invoke  CreateWindowEx, WS_EX_PALETTEWINDOW Or WS_EX_CLIENTEDGE,
							Addr szClassName, Addr szDisplayName,
							WS_OVERLAPPEDWINDOW Or LBS_HASSTRINGS Or \
							LBS_NOINTEGRALHEIGHT Or LBS_DISABLENOSCROLL, \
							Wtx, Wty, Wwd, Wht, NULL, NULL, hInst, NULL
	Mov     hwnd, Eax
	Mov     hMenu, FUNC(CreateMenu)     ; Main Menu
	Mov     hfMnu, FUNC(CreateMenu)     ; File Menu
	Mov     hhMnu, FUNC(CreateMenu)     ; Help Menu
;
;   File Menu
	Invoke  AppendMenu, hMenu, MF_POPUP, hfMnu, chr$("&File")
	Invoke  AppendMenu, hfMnu, MF_STRING, 1000, chr$("&Exit", 9, "Alt+F4")
;
;   Help Menu
	Invoke  AppendMenu, hMenu, MF_POPUP, hhMnu, chr$("&Help")
	Invoke  AppendMenu, hhMnu, MF_STRING, 1900, chr$("&About")
;
	Invoke  SetMenu, hwnd, hMenu
	Invoke  ShowWindow, hwnd, SW_SHOWNORMAL
	Invoke  UpdateWindow, hwnd
;    _______________________________________
;   |                                       |
;   | Loop until the PostQuitMessage is sent|
;   |_______________________________________|
;
StartLoop:
	Invoke  GetMessage, Addr msg, NULL, 0, 0
	Cmp     Eax, 0
	Je      ExitLoop
	Invoke  TranslateMessage, Addr msg
	Invoke  DispatchMessage, Addr msg
	Jmp     StartLoop
ExitLoop:
	Return msg.wParam
;---------------------------------------
WinMain EndP
;
;
WndProc Proc Uses Edi Esi hWin:DWord, uMsg:DWord, wParam:DWord, lParam:DWord
;---------------------------------------
;	Menu Commands
	.If uMsg == WM_COMMAND
		.If wParam == 1000
			Invoke  SendMessage, hWin, WM_SYSCOMMAND, SC_CLOSE, NULL
		.ElseIf wParam == 1900
			Invoke  DialogBoxParam, hInstance, Addr SpecialDLGName, 0, Addr SpecialProc, 0 ; Show Information Dialog Box
		.EndIf
;	Menu Commands End
	.ElseIf uMsg == WM_CREATE
		Invoke  ListBox, 12, 14, 200, 200, hWin, 500
		Mov     hList, Eax
		Invoke  SetWindowLong, hList, GWL_WNDPROC, ListBoxProc
		Mov     lpListBox, Eax
;      _____________________________________________________
;     |                                                     |
;     | This block of code reads a string that is a list of |
;     | seperate items delimited by a single zero byte. The |
;     | list is terminated by a double zero byte pair.      |
;     |_____________________________________________________|
;
		Mov     Esi, Offset LineItem
		Mov     Edi, Offset ItemBuffer
@@:		Lodsb
		Cmp Al, 0                 		; Test for terminator
		Je Build                 		; Write to list
		Stosb
		Jmp     @B
Build:	Stosb                         	; Write terminator
		Invoke  SendMessage, hList, LB_ADDSTRING, 0, Addr ItemBuffer
		Lodsb
		Cmp Al, 0                 		; Check for second zero
		Je @F                    		; Exit if found
		Mov     Edi, Offset ItemBuffer  ; Reset to start of buffer
		Stosb                         	; Write test byte to it
		Jmp     @B
@@: .ElseIf uMsg == WM_CLOSE
		szText  TheText, "Please Confirm Exit"
		Invoke  MessageBox, hWin, Addr TheText, Addr szDisplayName, MB_YESNO
		.If Eax == IDNO
			Return 0
		.EndIf
	.ElseIf uMsg == WM_DESTROY
		Invoke  PostQuitMessage, NULL
		Return 0
	.EndIf
	Invoke  DefWindowProc, hWin, uMsg, wParam, lParam
	Ret
;---------------------------------------
WndProc EndP
;
;
TopXY   Proc    wDim:DWord, sDim:DWord
;-----------------------------------;
	Shr     sDim, 1                 ; Divide screen dimension by 2
	Shr     wDim, 1                 ; Divide window dimension by 2
	Mov     Eax, wDim               ; Copy window dimension into eax
	Sub     sDim, Eax               ; Sub half win dimension from half screen dimension
	Return	sDim                    ;
;-----------------------------------;
TopXY   EndP
;
;
ListBox Proc    a:DWord, b:DWord, wd:DWord, ht:DWord, hParent:DWord, ID:DWord
;---------------------------------------
	szText  lstBox, "LISTBOX"
	Invoke  CreateWindowEx, WS_EX_CLIENTEDGE, Addr lstBox, 0,
							WS_VSCROLL Or WS_VISIBLE Or WS_BORDER Or WS_CHILD Or \
							LBS_HASSTRINGS Or LBS_NOINTEGRALHEIGHT Or \
							LBS_DISABLENOSCROLL, a, b, wd, ht, hParent, ID, hInstance, NULL
	Ret
;---------------------------------------
ListBox EndP
;
;
ListBoxProc Proc Uses Esi hCtl:DWord, uMsg:DWord, wParam:DWord, lParam:DWord
;---------------------------------------
	Local   IndexItem:DWord
	Local   Buffer[32]:Byte
;
	.If uMsg == WM_LBUTTONDBLCLK
		Jmp DoIt
	.ElseIf uMsg == WM_CHAR
		.If wParam == 13
			Jmp DoIt
		.EndIf
	.EndIf
	Jmp     EndDo
DoIt:
	Invoke  SendMessage, hCtl, LB_GETCURSEL, 0, 0
	Mov     IndexItem, Eax
	Invoke  SendMessage, hCtl, LB_GETTEXT, IndexItem, Addr Buffer
	Mov     Eax, hList
	.If hCtl == Eax
		Lea     Esi, rsCreateEditor
		Invoke  lstrcmp, Addr Buffer, chr$("rsCreateEditor")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsChangeControlColors
		Invoke  lstrcmp, Addr Buffer, chr$("rsChangeControlColors")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsCheckModified
		Invoke  lstrcmp, Addr Buffer, chr$("rsCheckModified")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsClearNextUndoEntry
		Invoke  lstrcmp, Addr Buffer, chr$("rsClearNextUndoEntry")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsClearUndoBuffer
		Invoke  lstrcmp, Addr Buffer, chr$("rsClearUndoBuffer")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsCopyString
		Invoke  lstrcmp, Addr Buffer, chr$("rsCopyString")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsDecrementUndoCount
		Invoke  lstrcmp, Addr Buffer, chr$("rsDecrementUndoCount")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsDisplayCursor
		Invoke  lstrcmp, Addr Buffer, chr$("rsDisplayCursor")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsExpandTabStops
		Invoke  lstrcmp, Addr Buffer, chr$("rsExpandTabStops")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsFindFirstChar
		Invoke  lstrcmp, Addr Buffer, chr$("rsFindFirstChar")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsFindHook
		Invoke  lstrcmp, Addr Buffer, chr$("rsFindHook")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsFindNextWord
		Invoke  lstrcmp, Addr Buffer, chr$("rsFindNextWord")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsFindPrevWord
		Invoke  lstrcmp, Addr Buffer, chr$("rsFindPrevWord")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsFindText
		Invoke  lstrcmp, Addr Buffer, chr$("rsFindText")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsGetLineAndExpandTabs
		Invoke  lstrcmp, Addr Buffer, chr$("rsGetLineAndExpandTabs")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsGetLineFromChar
		Invoke  lstrcmp, Addr Buffer, chr$("rsGetLineFromChar")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsGetLineIndex
		Invoke  lstrcmp, Addr Buffer, chr$("rsGetLineIndex")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsGetLineLength
		Invoke  lstrcmp, Addr Buffer, chr$("rsGetLineLength")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsGetMemoryPosition
		Invoke  lstrcmp, Addr Buffer, chr$("rsGetMemoryPosition")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsGetNextLineIndex
		Invoke  lstrcmp, Addr Buffer, chr$("rsGetNextLineIndex")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsGetPrevLineIndex
		Invoke  lstrcmp, Addr Buffer, chr$("rsGetPrevLineIndex")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsGetRealColWidth
		Invoke  lstrcmp, Addr Buffer, chr$("rsGetRealColWidth")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsGetStringLength
		Invoke  lstrcmp, Addr Buffer, chr$("rsGetStringLength")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsInitEditor
		Invoke  lstrcmp, Addr Buffer, chr$("rsInitEditor")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsInsertText
		Invoke  lstrcmp, Addr Buffer, chr$("rsInsertText")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsIsAlpha
		Invoke  lstrcmp, Addr Buffer, chr$("rsIsAlpha")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsIsAlphaNumeric
		Invoke  lstrcmp, Addr Buffer, chr$("rsIsAlphaNumeric")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsLineScroll
		Invoke  lstrcmp, Addr Buffer, chr$("rsLineScroll")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsMakeSelectionVisible
		Invoke  lstrcmp, Addr Buffer, chr$("rsMakeSelectionVisible")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsMoveMemory
		Invoke  lstrcmp, Addr Buffer, chr$("rsMoveMemory")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsPaintControl
		Invoke  lstrcmp, Addr Buffer, chr$("rsPaintControl")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsProcessLButtonDown
		Invoke  lstrcmp, Addr Buffer, chr$("rsProcessLButtonDown")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsRedoAction
		Invoke  lstrcmp, Addr Buffer, chr$("rsRedoAction")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsReplaceSelection
		Invoke  lstrcmp, Addr Buffer, chr$("rsReplaceSelection")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsResizeTextBuffer
		Invoke  lstrcmp, Addr Buffer, chr$("rsResizeTextBuffer")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsSaveUndoBufer
		Invoke  lstrcmp, Addr Buffer, chr$("rsSaveUndoBufer")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsSaveUndoRedoText
		Invoke  lstrcmp, Addr Buffer, chr$("rsSaveUndoRedoText")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsSearchCaseDown
		Invoke  lstrcmp, Addr Buffer, chr$("rsSearchCaseDown")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsSearchCaseUp
		Invoke  lstrcmp, Addr Buffer, chr$("rsSearchCaseUp")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsSearchNoCaseDown
		Invoke  lstrcmp, Addr Buffer, chr$("rsSearchNoCaseDown")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsSearchNoCaseUp
		Invoke  lstrcmp, Addr Buffer, chr$("rsSearchNoCaseUp")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsSearchText
		Invoke  lstrcmp, Addr Buffer, chr$("rsSearchText")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsSelectWord
		Invoke  lstrcmp, Addr Buffer, chr$("rsSelectWord")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsSendNotifyMessage
		Invoke  lstrcmp, Addr Buffer, chr$("rsSendNotifyMessage")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsSetCaret
		Invoke  lstrcmp, Addr Buffer, chr$("rsSetCaret")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsSetFirstLineIndex
		Invoke  lstrcmp, Addr Buffer, chr$("rsSetFirstLineIndex")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsStoreUndoText
		Invoke  lstrcmp, Addr Buffer, chr$("rsStoreUndoText")
		Cmp     Eax, 0
		Je      found
		Lea     Esi, rsUndoAction
found:	Invoke  MessageBox, hwnd, Esi, Addr Buffer, MB_OK
	.EndIf
EndDo:
	Invoke  CallWindowProc, lpListBox, hCtl, uMsg, wParam, lParam
	Ret
;---------------------------------------
ListBoxProc EndP
;
;
SpecialProc Proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
	.If uMsg == WM_INITDIALOG       	; If 'Initialize Dialog' request...
		Invoke  SetDlgItemText, hWnd, 300, Addr SalaBlurb   ; Show the text message
		Ret                           	; Return  to caller
	.ElseIf uMsg==WM_COMMAND
		Mov Eax, wParam               	; Get the command
		.If Eax == 200
			Invoke  EndDialog, hWnd, 0
		.EndIf
	.ElseIf uMsg==WM_CLOSE
		Invoke  EndDialog, hWnd, 0
	.Else
		Mov     Eax, FALSE
		Ret
	.EndIf
	Mov     Eax, TRUE
	Ret
;---------------------------------------
SpecialProc EndP
;
;
	End     start
