;===========================================================================
; RSEditor constants
;===========================================================================

GWL_EDITORDATA			Equ		0

RSV_CHANGE				Equ		00000001H
RSV_HSCROLL				Equ		00000002H
RSV_KILLFOCUS			Equ		00000004H
RSV_SELCHANGE			Equ		00000008H
RSV_SETFOCUS			Equ		00000010H
RSV_UPDATE				Equ		00000020H
RSV_VSCROLL				Equ		00000040H

RSC_UP					Equ		0
RSC_DOWN				Equ		1
RSC_MATCHCASE			Equ		2
RSC_WHOLEWORD			Equ		4
RSC_SELECTTEXT			Equ		8

RSC_TEXT				Equ		01H
RSC_LINES				Equ		02H
RSC_UNDO				Equ		04H

CHAR_SIZE				Equ		1
MIN_LINE_SIZE			Equ		16 * CHAR_SIZE
MAX_LINE_SIZE			Equ		2048

PAINT_NONE				Equ		0
PAINT_LINE				Equ		1
PAINT_FROM_LINE			Equ		2
PAINT_FROM_PREV_LINE	Equ		3
PAINT_ALL				Equ		4

SCROLL_HORZ				Equ		01H
SCROLL_VERT				Equ		02H

KEY_ALT					Equ		01H
KEY_CTRL				Equ		02H
KEY_SHIFT				Equ		04H

STATE_BOOKMARK			Equ		02H
STATE_LOCKED			Equ		04H

CR						Equ		13
LF						Equ		10
TAB						Equ		9


;===========================================================================
; RSEditor styles
;===========================================================================

RSS_SPLIT				Equ		1


;===========================================================================
; RSEditor structures
;===========================================================================

RSSCHARSEL Struct
	lMin				LONG		?
	lMax				LONG		?
RSSCHARSEL EndS

RSSCHARINFO Struct
	lLine				LONG		?
	lLineIndex			LONG		?
	lLineOffset			LONG		?
RSSCHARINFO EndS

RSSFINDTEXT Struct
	chr					RSSCHARSEL	<?>
	lpstr				LPSTR	?
RSSFINDTEXT EndS

RSSEDITFONT Struct
	lPoints				LONG		?
	lWeight				LONG		?
	bItalic				BOOL		?
	bStrikethru			BOOL		?
	bUnderline			BOOL		?
	dwCharSet			DWord		?
	szFaceName			CHAR 32 Dup(?)
RSSEDITFONT EndS

LINE Struct
	lpszText			LPLONG 		?
	lLength 			LONG 		?
	lMaxLength			LONG		?
	lState				LONG		?
LINE EndS

EDITCHILD Struct
	hWnd				HWND		?
	hWndVScroll			HWND		?
	bNoSelection		BOOL		?
	lCurCol				LONG		?
	lCurLine			LONG		?
	lLastCol			LONG		?
	lPaint				LONG		?
	lRealCol			LONG		?
	lSelStart			LONG		?
	lTopLine			LONG		?
	lTopLineIndex		LONG		?
	lVScrollPage		LONG		?
	rc					RECT		<?>
	chrPos				RSSCHARSEL 	<?>
	chrSel				RSSCHARSEL 	<?>
EDITCHILD EndS

EDITPARENT Struct
	hWnd				HWND		?
	hWndParent			HWND		?
	Editor				EDITCHILD	<?>
	Mirror				EDITCHILD	<?>
	hWndFocus			HWND		?
	hWndGrip			HWND		?
	hWndHScroll			HWND		?
	hWndNoGrip			HWND		?
	hWndSplitter		HWND		?
	hWndTimer			HWND		?
	bAutoIndent			BOOL		?
	bCaret				BOOL		?
	bChangeEvent		BOOL		?
	bHideGrip			BOOL		?
	bHideSelection		BOOL		?
	bInsert				BOOL		?
	bModified			BOOL		?
	bReadOnly			BOOL		?
	bTabToSpaces		BOOL		?
	lCaretWidth			LONG		?
	lCtrlID				LONG		?
	lHScrollMax			LONG		?
	lHScrollPage		LONG		?
	lHScrollPos			LONG		?
	lLastUndoCount		LONG		?
	lLines				LONG		?
	lMarginWidth		LONG		?
	lMaxIndex			LONG		?
	lMaxLines			LONG		?
	lMaxTextLength		LONG		?
	lMaxUndo			LONG		?
	lMouseWheelUnits	LONG		?
	lScrollCounter		LONG		?
	uScrollTimer		UINT		?
	lTabSize			LONG		?
	lUndoCount			LONG		?
	dwEventMask			DWord		?
	lpszBuffer			LPSTR		?
	lpszLine			LPSTR		?
	lpszNextText		LPSTR		?
	lpLinesPointer		LPLONG		?
	lpTextPointer		LPLONG		?
	lpUndoPointer		LPLONG		?
	RSIsAlphaProcAddr	WNDPROC		?
	hFont				HFONT		?
	rc					RECT		<?>
	szFont				SIZEL		<?>
	crBackColor			COLORREF	?
	crTextColor 		COLORREF 	?
	crBackSelect 		COLORREF 	?
	crTextSelect 		COLORREF 	?
	crBackMargin		COLORREF	?
	crBackLocked		COLORREF	?
	crTextLocked		COLORREF	?
EDITPARENT EndS

EDITUNDO Struct
	lpszText			LPSTR		?
	lTopLine			LONG		?
	chrPos				RSSCHARSEL 	<?>
EDITUNDO EndS


;===========================================================================
; RSEditor messages
;===========================================================================

RSM_FIRST					Equ		WM_USER + 200
RSM_CHANGEACTIVEEDITOR		Equ		RSM_FIRST
RSM_CLEARBOOKMARKS			Equ		RSM_FIRST + 1
RSM_CLEARUNDOBUFFER			Equ		RSM_FIRST + 2
RSM_CREATEFONT				Equ		RSM_FIRST + 3
RSM_FINDTEXT				Equ		RSM_FIRST + 4
RSM_GETBACKCOLOR			Equ		RSM_FIRST + 5
RSM_GETBACKMARGIN			Equ		RSM_FIRST + 6
RSM_GETBACKSELECT			Equ		RSM_FIRST + 7
RSM_GETEVENTMASK			Equ		RSM_FIRST + 8
RSM_GETHIDESELECTION		Equ		RSM_FIRST + 9
RSM_GETLASTPOSITION			Equ		RSM_FIRST + 10
RSM_GETLINECOUNT			Equ		RSM_FIRST + 11
RSM_GETLINELENGTH			Equ		RSM_FIRST + 12
RSM_GETLOCKEDBACKCOLOR		Equ		RSM_FIRST + 13
RSM_GETLOCKEDTEXTCOLOR		Equ		RSM_FIRST + 14
RSM_GETMARGINWIDTH			Equ		RSM_FIRST + 15
RSM_GETNEXTBOOKMARK			Equ		RSM_FIRST + 16
RSM_GETPOSITION				Equ		RSM_FIRST + 17
RSM_GETPREVBOOKMARK			Equ		RSM_FIRST + 18
RSM_GETPREVNEXTBOOKMARK		Equ		RSM_FIRST + 19
RSM_GETSELECTEDTEXT			Equ		RSM_FIRST + 20
RSM_GETSELECTION			Equ		RSM_FIRST + 21
RSM_GETSELTEXTLENGTH		Equ		RSM_FIRST + 22
RSM_GETTABSIZE				Equ		RSM_FIRST + 23
RSM_GETTABTOSPACES			Equ		RSM_FIRST + 24
RSM_GETTEXTCOLOR			Equ		RSM_FIRST + 25
RSM_GETTEXTSELECT			Equ		RSM_FIRST + 26
RSM_GETWORDFIRSTPOSITION	Equ		RSM_FIRST + 27
RSM_GETWORDLASTPOSITION		Equ		RSM_FIRST + 28
RSM_GETWORDUNDERCURSOR		Equ		RSM_FIRST + 29
RSM_GOTONEXTBOOKMARK		Equ		RSM_FIRST + 30
RSM_GOTOPREVBOOKMARK		Equ		RSM_FIRST + 31
RSM_ISCURRENTLINEBOOKMARKED	Equ		RSM_FIRST + 32
RSM_LOCKLINES				Equ		RSM_FIRST + 33
RSM_OPENFILE				Equ		RSM_FIRST + 34
RSM_RBUTTONCLICKED			Equ		RSM_FIRST + 35
RSM_REPLACESELECTION		Equ		RSM_FIRST + 36
RSM_SAVEFILE				Equ		RSM_FIRST + 37
RSM_SELECTALLTEXT			Equ		RSM_FIRST + 38
RSM_SETAUTOINDENT			Equ		RSM_FIRST + 39
RSM_SETBACKCOLOR			Equ		RSM_FIRST + 40
RSM_SETBACKMARGIN			Equ		RSM_FIRST + 41
RSM_SETBACKSELECT			Equ		RSM_FIRST + 42
RSM_SETCHARPROCADDRESS		Equ		RSM_FIRST + 43
RSM_SETEVENTMASK			Equ		RSM_FIRST + 44
RSM_SETHIDEGRIP				Equ		RSM_FIRST + 45
RSM_SETHIDESELECTION		Equ		RSM_FIRST + 46
RSM_SETINDENT				Equ		RSM_FIRST + 47
RSM_SETLOCKEDBACKCOLOR		Equ		RSM_FIRST + 48
RSM_SETLOCKEDTEXTCOLOR		Equ		RSM_FIRST + 49
RSM_SETMARGINWIDTH			Equ		RSM_FIRST + 50
RSM_SETSEARCHHANDLE			Equ		RSM_FIRST + 51
RSM_SETSELECTION			Equ		RSM_FIRST + 52
RSM_SETTABSIZE				Equ		RSM_FIRST + 53
RSM_SETTABTOSPACES			Equ		RSM_FIRST + 54
RSM_SETTEXTCOLOR			Equ		RSM_FIRST + 55
RSM_SETTEXTSELECT			Equ		RSM_FIRST + 56
RSM_SETWORDBREAK			Equ		RSM_FIRST + 57
RSM_TOGGLEBOOKMARK			Equ		RSM_FIRST + 58
RSM_UNLOCKLINES				Equ		RSM_FIRST + 59
RSM_UPDATEEDITFUNCTIONS		Equ		RSM_FIRST + 60
RSM_LAST					Equ		RSM_FIRST + 60
